# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AppsActivity.V1.Model.Activity do
  @moduledoc """
  An Activity resource is a combined view of multiple events. An activity has a list of individual events and a combined view of the common fields among all events.

  ## Attributes

  *   `combinedEvent` (*type:* `GoogleApi.AppsActivity.V1.Model.Event.t`, *default:* `nil`) - The fields common to all of the singleEvents that make up the Activity.
  *   `singleEvents` (*type:* `list(GoogleApi.AppsActivity.V1.Model.Event.t)`, *default:* `nil`) - A list of all the Events that make up the Activity.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :combinedEvent => GoogleApi.AppsActivity.V1.Model.Event.t(),
          :singleEvents => list(GoogleApi.AppsActivity.V1.Model.Event.t())
        }

  field(:combinedEvent, as: GoogleApi.AppsActivity.V1.Model.Event)
  field(:singleEvents, as: GoogleApi.AppsActivity.V1.Model.Event, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.AppsActivity.V1.Model.Activity do
  def decode(value, options) do
    GoogleApi.AppsActivity.V1.Model.Activity.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AppsActivity.V1.Model.Activity do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
