# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AppsActivity.V1.Model.ListActivitiesResponse do
  @moduledoc """
  The response from the list request. Contains a list of activities and a token to retrieve the next page of results.

  ## Attributes

  *   `activities` (*type:* `list(GoogleApi.AppsActivity.V1.Model.Activity.t)`, *default:* `nil`) - List of activities.
  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token for the next page of results.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :activities => list(GoogleApi.AppsActivity.V1.Model.Activity.t()),
          :nextPageToken => String.t()
        }

  field(:activities, as: GoogleApi.AppsActivity.V1.Model.Activity, type: :list)
  field(:nextPageToken)
end

defimpl Poison.Decoder, for: GoogleApi.AppsActivity.V1.Model.ListActivitiesResponse do
  def decode(value, options) do
    GoogleApi.AppsActivity.V1.Model.ListActivitiesResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AppsActivity.V1.Model.ListActivitiesResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
